
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#pragma once

#include "ExcelClone.h"


class CRange;

/*
	CXLFont class represents Font Excel object. It contains the font attributes 
	(font name, font size, color, and so on) for an object.

*/
class ATL_NO_VTABLE CXLFont :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IXLFont, &IID_IXLFont, &LIBID_ExcelCloneLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
    CXLFont();
    ~CXLFont();

    HRESULT Initialize(CRange *pRange);

    BEGIN_COM_MAP(CXLFont)
        COM_INTERFACE_ENTRY(IXLFont)
        COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

public:
    STDMETHOD(get_Bold)(VARIANT_BOOL *pvbBold);
    STDMETHOD(put_Bold)(VARIANT_BOOL vbBold);
	// True if the font is bold
    
    STDMETHOD(get_Italic)(VARIANT_BOOL *pvbItalic);
    STDMETHOD(put_Italic)(VARIANT_BOOL vbItalic);
	// True if the font is Italic

    STDMETHOD(get_Underline)(VARIANT_BOOL *pvbUnderline);
    STDMETHOD(put_Underline)(VARIANT_BOOL vbUnderline);
	// True if the font is Underline

protected:
    CRange *m_pRange;
};

typedef CComObject<CXLFont> CXLFontObject;
typedef CComPtr<CXLFontObject> CXLFontObjectPtr;
