
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

/*
	CApplication class implements methods of Application Word object.
	The main purpose of this clas is to retreive WordBasic object.
*/

#include "stdafx.h"
#include "Application.h"


CApplication::CApplication() 
{
    WRITE_LOG_R_W((L"CApplication::CApplication()"));
}

CApplication::~CApplication()
{
    WRITE_LOG_R_W((L"CApplication::~CApplication()"));
}

// get_Version property, always return "11.0" version
STDMETHODIMP CApplication::get_Version(BSTR *pVersion)
{
    WRITE_LOG_R_W((L"CApplication::get_Version(...)"));
    if (pVersion == NULL)
    {
        return E_POINTER;
    }

    *pVersion = ::SysAllocString(OLESTR("11.0"));

    return S_OK;
}

// get_WordBasic method, create and return IDispatch for WordBasic object
STDMETHODIMP CApplication::get_WordBasic(IDispatch **ppWordBasic)
{
    WRITE_LOG_R_W((L"CApplication::get_WordBasic(...)"));

    if (ppWordBasic == NULL)
    {
        return E_POINTER;
    }


    HRESULT hres = ::CoCreateInstance(CLSID_WordBasic, 
                                    NULL, 
                                    CLSCTX_INPROC, 
                                    IID_IDispatch, 
                                    (void**)ppWordBasic);
    return hres;
}

// Quit, do nothing:)
STDMETHODIMP CApplication::Quit(VARIANT* SaveChanges, VARIANT* OriginalFormat, VARIANT* RouteDocument)
{
    WRITE_LOG_R_W((L"CApplication::Quit(...)"));
    return S_OK;
}
