
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#pragma once

#include "resource.h"
#include "WordClone.h"
#include "WordBasic.h"



/*
	CApplication class implements methods of Application Word object.
	The main purpose of this clas is to retreive WordBasic object.
*/
class ATL_NO_VTABLE CApplication : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CApplication, &CLSID_Application>,
	public IDispatchImpl<IApplication, &IID_IApplication, &LIBID_WordCloneLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CApplication();
	~CApplication();

    DECLARE_CLASSFACTORY_SINGLETON(CApplication)

    DECLARE_REGISTRY_RESOURCEID(IDR_WORDAPPLICATION)

    DECLARE_NOT_AGGREGATABLE(CApplication)

    BEGIN_COM_MAP(CApplication)
	    COM_INTERFACE_ENTRY(IApplication)
	    COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public: 
    // IApplication methods

    STDMETHOD(get_WordBasic)(IDispatch **ppWordBasic);

    STDMETHOD(get_Version)(BSTR *pVersion);

    STDMETHOD(Quit) (VARIANT* SaveChanges, 
                     VARIANT* OriginalFormat, 
                     VARIANT* RouteDocument);

protected:
    //CWordBasicObject m_WordBasic;
public : 
    
};

OBJECT_ENTRY_AUTO(__uuidof(Application), CApplication)
